"use strict";
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
Object.defineProperty(exports, "__esModule", { value: true });
var use_force_update_1 = require("use-force-update");
var zeroStyles = function (i) {
    var properties = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        properties[_i - 1] = arguments[_i];
    }
    var e_1, _a;
    try {
        for (var properties_1 = __values(properties), properties_1_1 = properties_1.next(); !properties_1_1.done; properties_1_1 = properties_1.next()) {
            var property = properties_1_1.value;
            i.style.setProperty(property, '0');
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (properties_1_1 && !properties_1_1.done && (_a = properties_1.return)) _a.call(properties_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
};
var createInput = function () {
    var i = document.createElement('input');
    i.setAttribute('size', '0');
    zeroStyles(i, 'border-width', 'bottom', 'margin-left', 'margin-top', 'outline-width', 'padding-bottom', 'padding-left', 'padding-right', 'padding-top', 'right');
    i.style.setProperty('box-sizing', 'border-box');
    i.style.setProperty('height', '1px');
    i.style.setProperty('margin-bottom', '-1px');
    i.style.setProperty('margin-right', '-1px');
    i.style.setProperty('max-height', '1px');
    i.style.setProperty('max-width', '1px');
    i.style.setProperty('min-height', '1px');
    i.style.setProperty('min-width', '1px');
    i.style.setProperty('outline-color', 'transparent');
    i.style.setProperty('position', 'absolute');
    i.style.setProperty('width', '1px');
    document.body.appendChild(i);
    return i;
};
var removeInput = function (i) {
    document.body.removeChild(i);
};
var read = function () {
    var i = createInput();
    i.focus();
    document.execCommand('paste');
    var value = i.value;
    removeInput(i);
    return value;
};
var write = function (text) {
    var i = createInput();
    i.setAttribute('value', text);
    i.select();
    document.execCommand('copy');
    removeInput(i);
};
var useClippy = function (rerender) {
    if (rerender === void 0) { rerender = true; }
    var forceUpdate = use_force_update_1.default();
    return [
        read(),
        function clipboardWrite(text) {
            write(text);
            if (rerender) {
                forceUpdate();
            }
        }
    ];
};
exports.default = useClippy;
module.exports = useClippy;
module.exports.default = useClippy;
